//------------------------------------------------------------------------------
//
// Copyright (c) 2004-2005  Matt Brunk  <info@smartcache.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License VERSION 2 as
// published by the Free Software Foundation.  You are not allowed to
// use any other version of the license; unless you got the explicit
// permission from the author to do so.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//------------------------------------------------------------------------------
#ifndef ACOS1_H_INCLUDED__
#define ACOS1_H_INCLUDED__

#include "SoftCardTypes.h"
#include "TripleDES.h"

#pragma warning( push, 1 )
#include <vector>
#pragma warning( pop )

typedef U8	U8_8[8];
typedef U8	U8_4[4];

typedef struct
{
	U8	recordLength;
	U8	numRecords;
	U8	readSecurityAttribute;
	U8	writeSecurityAttribute;
	U16	fileIdentifier;
} UserFileDefinitionStruct;

typedef struct
{
	UserFileDefinitionStruct	ufd;
	U8							*data;
} UserFileStruct;

class CACOS1
{
public:

	CACOS1();
	virtual ~CACOS1();

	void	SetATR(U8 *atr, UINT length);
	void	GetATR(U8 *atr, UINT &length);
	void	GetDefaultATR(U8 *atr, UINT &length);
	void	NewCard();
	void	ProcessCommand(U8 *cmd, U8 *response, UINT &responseLength);
	void	ProcessCommandData(U8 *data, UINT length, U8 *response, UINT &responseLength);
	void	DoATR();

private:

	bool		IsValidFile(U16 file);

	U8			m_atr[MAX_ATR_LENGTH];
	UINT		m_iAtrLength;	
	UINT		m_eStage;
	U8			m_cmd[5];
	U8			m_password[8];
	UINT		m_passwordLength;
	UINT		m_iNumIncorrectICs;
	U16			m_currFile;
	U8_8		m_manufacturingFile[2];
	bool		m_bFileSelected;
	U8_4		m_personalizationFile[3];
	UINT		m_N_OF_FILE;
	U8_8		m_securityFile[14];
	U8			m_RNDc[8];
	U8			m_RNDt[8];
	TripleDesBufType	m_Ks_left;
	TripleDesBufType	m_Ks_right;


	std::vector<UserFileStruct>	m_userFiles;

};
#endif	// ACOS1_H_INCLUDED__
